;Kernel entry point

[BITS 32]
global start
start:
        mov esp, _sys_stack  ; points to new stack area
        jmp stublet
; 4bytes align
ALIGN 4
mboot:
        ;Multiboot macros
        MULTIBOOT_PAGE_ALIGN equ 1<<0
        MULTIBOOT_MEMORY_INFO equ 1<<1
        MULTIBOOT_AOUT_KLUDGE equ 1<<16
        MULTIBOOT_HEADER_MAGIC equ 0x1BABB002
        MULTIBOOT_HEADER_FLAGS equ MULTIBOOT_PAGE_ALIGN |MULTIBOOT_MEMORY_INFO | MULTIBOOT_AOUT_KLUDGE
        MULTIBOOT_CHECKSUM equ -(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS)
        EXTERN code, bss, end


        ; GRUB Multiboot header. A boot signature
        dd MULTIBOOT_HEADER_MAGIC
        dd MULTIBOOT_HEADER_FLAGS
        dd MULTIBOOT_CHECKSUM

        ;AOUT kludge - must physical address.
        ; linker script fills in the data for these ones!

        dd mboot
        dd code
        dd bss
        dd end
        dd start

; endless loop here
; insert an 'extern _main', follwed by 'call _main', right before 'jmp $'
stublet:
        extern main
        call main
        jmp $

; load GDT here

; interrupt service routine here


; BSS definition to store stack

; declare the size of the data before '_sys_stack'

SECTION .bss
        resb 8192 ; reserves 8 bytes 0f memory
_sys_stack:
